---
title: Developer platform Changelog
image: https://developers.cloudflare.com/cf-twitter-card.png
---

> Documentation Index  
> Fetch the complete documentation index at: https://developers.cloudflare.com/changelog/llms.txt  
> Use this file to discover all available pages before exploring further. 

[Skip to content](#%5Ftop) 

# Changelog

New updates and improvements at Cloudflare.

[ Subscribe to RSS ](https://developers.cloudflare.com/changelog/rss/index.xml) [ View RSS feeds ](https://developers.cloudflare.com/fundamentals/new-features/available-rss-feeds/) 

Developer platform

![hero image](https://developers.cloudflare.com/_astro/hero.CVYJHPAd_26AMqX.svg) 

Mar 07, 2025
1. ### [Hyperdrive reduces query latency by up to 90% and now supports IP access control lists](https://developers.cloudflare.com/changelog/post/2025-03-04-hyperdrive-pooling-near-database-and-ip-range-egress/)  
[ Hyperdrive ](https://developers.cloudflare.com/hyperdrive/)  
Hyperdrive now pools database connections in one or more regions close to your database. This means that your uncached queries and new database connections have up to 90% less latency as measured from connection pools.  
![Hyperdrive query latency decreases by 90% during Hyperdrive's gradual rollout of regional pooling.](https://developers.cloudflare.com/_astro/hyperdrive-regional-pooling-query-latency-improvement.Bzz_xvHZ_rlYbl.webp)  
By improving placement of Hyperdrive database connection pools, Workers' Smart Placement is now more effective when used with Hyperdrive, ensuring that your Worker can be placed as close to your database as possible.  
With this update, Hyperdrive also uses [Cloudflare's standard IP address ranges ↗](https://www.cloudflare.com/ips/) to connect to your database. This enables you to configure the firewall policies (IP access control lists) of your database to only allow access from Cloudflare and Hyperdrive.  
Refer to [documentation on how Hyperdrive makes connecting to regional databases from Cloudflare Workers fast](https://developers.cloudflare.com/hyperdrive/concepts/how-hyperdrive-works/).  
This improvement is enabled on all Hyperdrive configurations.

Mar 06, 2025
1. ### [Set retention polices for your R2 bucket with bucket locks](https://developers.cloudflare.com/changelog/post/2025-03-06-r2-bucket-locks/)  
[ R2 ](https://developers.cloudflare.com/r2/)  
You can now use [bucket locks](https://developers.cloudflare.com/r2/buckets/bucket-locks/) to set retention policies on your [R2 buckets](https://developers.cloudflare.com/r2/buckets/) (or specific prefixes within your buckets) for a specified period — or indefinitely. This can help ensure compliance by protecting important data from accidental or malicious deletion.  
Locks give you a few ways to ensure your objects are retained (not deleted or overwritten). You can:

  * Lock objects for a specific duration, for example 90 days.
  * Lock objects until a certain date, for example January 1, 2030.
  * Lock objects indefinitely, until the lock is explicitly removed.  
Buckets can have up to 1,000 [bucket lock rules](https://developers.cloudflare.com/r2/buckets/). Each rule specifies which objects it covers (via prefix) and how long those objects must remain retained.  
Here are a couple of examples showing how you can configure bucket lock rules using [Wrangler](https://developers.cloudflare.com/workers/wrangler/):  
#### Ensure all objects in a bucket are retained for at least 180 days  
Terminal window  
```  
npx wrangler r2 bucket lock add <bucket> --name 180-days-all --retention-days 180  
```  
#### Prevent deletion or overwriting of all logs indefinitely (via prefix)  
Terminal window  
```  
npx wrangler r2 bucket lock add <bucket> --name indefinite-logs --prefix logs/ --retention-indefinite  
```  
For more information on bucket locks and how to set retention policies for objects in your R2 buckets, refer to our [documentation](https://developers.cloudflare.com/r2/buckets/bucket-locks/).

Mar 06, 2025
1. ### [Introducing Media Transformations from Cloudflare Stream](https://developers.cloudflare.com/changelog/post/2025-03-06-media-transformations/)  
[ Stream ](https://developers.cloudflare.com/stream/)  
Today, we are thrilled to announce Media Transformations, a new service that brings the magic of [Image Transformations](https://developers.cloudflare.com/images/optimization/transformations/overview/) to _short-form video files,_ wherever they are stored!  
For customers with a huge volume of short video — generative AI output, e-commerce product videos, social media clips, or short marketing content — uploading those assets to Stream is not always practical. Sometimes, the greatest friction to getting started was the thought of all that migrating. Customers want a simpler solution that retains their current storage strategy to deliver small, optimized MP4 files. Now you can do that with Media Transformations.  
To transform a video or image, [enable transformations](https://developers.cloudflare.com/stream/transform-videos/#getting-started) for your zone, then make a simple request with a specially formatted URL. The result is an MP4 that can be used in an HTML video element without a player library. If your zone already has Image Transformations enabled, then it is ready to optimize videos with Media Transformations, too.  
URL format  
```  
https://example.com/cdn-cgi/media/<OPTIONS>/<SOURCE-VIDEO>  
```  
For example, we have a short video of the mobile in Austin's office. The original is nearly 30 megabytes and wider than necessary for this layout. Consider a simple width adjustment:  
Example URL  
```  
https://example.com/cdn-cgi/media/width=640/<SOURCE-VIDEO>https://developers.cloudflare.com/cdn-cgi/media/width=640/https://pub-d9fcbc1abcd244c1821f38b99017347f.r2.dev/aus-mobile.mp4  
```  
The result is less than 3 megabytes, properly sized, and delivered dynamically so that customers do not have to manage the creation and storage of these transformed assets.  
For more information, learn about [Transforming Videos](https://developers.cloudflare.com/stream/transform-videos/).

Feb 28, 2025
1. ### [Use the latest JavaScript features with Wrangler CLI v4.0.0-rc.0](https://developers.cloudflare.com/changelog/post/2025-02-28-wrangler-v4-rc/)  
[ Workers ](https://developers.cloudflare.com/workers/)  
We've released a release candidate of the next major version of [Wrangler](https://developers.cloudflare.com/workers/wrangler/), the CLI for Cloudflare Workers — `wrangler@4.0.0-rc.0`.  
You can run the following command to install it and be one of the first to try it out:  
 npm  yarn  pnpm  bun  
```  
npm i wrangler@v4-rc  
```  
```  
yarn add wrangler@v4-rc  
```  
```  
pnpm add wrangler@v4-rc  
```  
```  
bun add wrangler@v4-rc  
```  
Unlike previous major versions of Wrangler, which were [foundational rewrites ↗](https://blog.cloudflare.com/wrangler-v2-beta/) and [rearchitectures ↗](https://blog.cloudflare.com/wrangler3/) — Version 4 of Wrangler includes a much smaller set of changes. If you use Wrangler today, your workflow is very unlikely to change. Before we release Wrangler v4 and advance past the release candidate stage, we'll share a detailed migration guide in the Workers developer docs. But for the vast majority of cases, you won't need to do anything to migrate — things will just work as they do today. We are sharing this release candidate in advance of the official release of v4, so that you can try it out early and share feedback.  
#### New JavaScript language features that you can now use with Wrangler v4  
Version 4 of Wrangler updates the version of [esbuild ↗](https://esbuild.github.io/) that Wrangler uses internally, allowing you to use modern JavaScript language features, including:  
##### The `using` keyword from Explicit Resource Management  
The [using keyword from the Explicit Resource Management standard](https://developers.cloudflare.com/workers/runtime-apis/rpc/lifecycle/#explicit-resource-management) makes it easier to work with the [JavaScript-native RPC system built into Workers](https://developers.cloudflare.com/workers/runtime-apis/rpc/). This means that when you obtain a stub, you can ensure that it is automatically disposed when you exit scope it was created in:  
JavaScript  
```  
function sendEmail(id, message) {  using user = await env.USER_SERVICE.findUser(id);  await user.sendEmail(message);  
  // user[Symbol.dispose]() is implicitly called at the end of the scope.}  
```  
##### Import attributes  
[Import attributes ↗](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Statements/import/with) allow you to denote the type or other attributes of the module that your code imports. For example, you can import a JSON module, using the following syntax:  
JavaScript  
```  
import data from "./data.json" with { type: "json" };  
```  
#### Other changes  
##### `--local` is now the default for all CLI commands  
All commands that access resources (for example, `wrangler kv`, `wrangler r2`, `wrangler d1`) now access local datastores by default, ensuring consistent behavior.  
##### Clearer policy for the minimum required version of Node.js required to run Wrangler  
Moving forward, the [active, maintenance, and current versions of Node.js ↗](https://nodejs.org/en/about/previous-releases) will be officially supported by Wrangler. This means the minimum officially supported version of Node.js you must have installed for Wrangler v4 will be Node.js v18 or later. This policy mirrors how many other packages and CLIs support older versions of Node.js, and ensures that as long as you are using a version of Node.js that the Node.js project itself supports, this will be supported by Wrangler as well.  
##### Features previously deprecated in Wrangler v3 are now removed in Wrangler v4  
All previously deprecated features in [Wrangler v2 ↗](https://developers.cloudflare.com/workers/wrangler/deprecations/#wrangler-v2) and in [Wrangler v3 ↗](https://developers.cloudflare.com/workers/wrangler/deprecations/#wrangler-v3) have now been removed. Additionally, the following features that were deprecated during the Wrangler v3 release have been removed:

  * Legacy Assets (using `wrangler dev/deploy --legacy-assets` or the `legacy_assets` config file property). Instead, we recommend you [migrate to Workers assets ↗](https://developers.cloudflare.com/workers/static-assets/).
  * Legacy Node.js compatibility (using `wrangler dev/deploy --node-compat` or the `node_compat` config file property). Instead, use the [nodejs\_compat compatibility flag ↗](https://developers.cloudflare.com/workers/runtime-apis/nodejs). This includes the functionality from legacy `node_compat` polyfills and natively implemented Node.js APIs.
  * `wrangler version`. Instead, use `wrangler --version` to check the current version of Wrangler.
  * `getBindingsProxy()` (via `import { getBindingsProxy } from "wrangler"`). Instead, use the [getPlatformProxy() API ↗](https://developers.cloudflare.com/workers/wrangler/api/#getplatformproxy), which takes exactly the same arguments.
  * `usage_model`. This no longer has any effect, after the [rollout of Workers Standard Pricing ↗](https://blog.cloudflare.com/workers-pricing-scale-to-zero/).  
We'd love your feedback! If you find a bug or hit a roadblock when upgrading to Wrangler v4, [open an issue on the cloudflare/workers-sdk repository on GitHub ↗](https://github.com/cloudflare/workers-sdk/issues/new?template=bug-template.yaml).

Feb 27, 2025
1. ### [New REST API is in open beta!](https://developers.cloudflare.com/changelog/post/2025-02-27-br-rest-api-beta/)  
[ Browser Run ](https://developers.cloudflare.com/browser-run/)  
We've released a new REST API for [Browser Rendering](https://developers.cloudflare.com/browser-run/) in open beta, making interacting with browsers easier than ever. This new API provides endpoints for common browser actions, with more to be added in the future.  
With the **REST API** you can:

  * **Capture screenshots** – Use `/screenshot` to take a screenshot of a webpage from provided URL or HTML.
  * **Generate PDFs** – Use `/pdf` to convert web pages into PDFs.
  * **Extract HTML content** – Use `/content` to retrieve the full HTML from a page. **Snapshot (HTML + Screenshot)** – Use `/snapshot` to capture both the page's HTML and a screenshot in one request
  * **Scrape Web Elements** – Use `/scrape` to extract specific elements from a page.  
For example, to capture a screenshot:  
Screenshot example  
```  
curl -X POST 'https://api.cloudflare.com/client/v4/accounts/<accountId>/browser-rendering/screenshot' \  -H 'Authorization: Bearer <apiToken>' \  -H 'Content-Type: application/json' \  -d '{    "html": "Hello World!",    "screenshotOptions": {      "type": "webp",      "omitBackground": true    }  }' \  --output "screenshot.webp"  
```  
Learn more in our [documentation](https://developers.cloudflare.com/browser-run/quick-actions/).

Feb 26, 2025
1. ### [Introducing Guardrails in AI Gateway](https://developers.cloudflare.com/changelog/post/2025-02-26-guardrails/)  
[ AI Gateway ](https://developers.cloudflare.com/ai-gateway/)  
[AI Gateway](https://developers.cloudflare.com/ai-gateway/) now includes [Guardrails](https://developers.cloudflare.com/ai-gateway/features/guardrails/), to help you monitor your AI apps for harmful or inappropriate content and deploy safely.  
Within the AI Gateway settings, you can configure:

  * **Guardrails**: Enable or disable content moderation as needed.
  * **Evaluation scope**: Select whether to moderate user prompts, model responses, or both.
  * **Hazard categories**: Specify which categories to monitor and determine whether detected inappropriate content should be blocked or flagged.  
![Guardrails in AI Gateway](https://developers.cloudflare.com/_astro/Guardrails.BTNc0qeC_Z1HC20z.webp)  
Learn more in the [blog ↗](https://blog.cloudflare.com/guardrails-in-ai-gateway/) or our [documentation](https://developers.cloudflare.com/ai-gateway/features/guardrails/).

Feb 25, 2025
1. ### [Introducing the Agents SDK](https://developers.cloudflare.com/changelog/post/2025-02-25-agents-sdk/)  
[ Agents ](https://developers.cloudflare.com/agents/)[ Workers ](https://developers.cloudflare.com/workers/)  
We've released the [Agents SDK ↗](http://blog.cloudflare.com/build-ai-agents-on-cloudflare/), a package and set of tools that help you build and ship AI Agents.  
You can get up and running with a [chat-based AI Agent ↗](https://github.com/cloudflare/agents-starter) (and deploy it to Workers) that uses the Agents SDK, tool calling, and state syncing with a React-based front-end by running the following command:  
Terminal window  
```  
npm create cloudflare@latest agents-starter -- --template="cloudflare/agents-starter"# open up README.md and follow the instructions  
```  
You can also add an Agent to any existing Workers application by installing the `agents` package directly  
Terminal window  
```  
npm i agents  
```  
... and then define your first Agent:  
TypeScript  
```  
import { Agent } from "agents";  
export class YourAgent extends Agent<Env> {  // Build it out  // Access state on this.state or query the Agent's database via this.sql  // Handle WebSocket events with onConnect and onMessage  // Run tasks on a schedule with this.schedule  // Call AI models  // ... and/or call other Agents.}  
```  
Head over to the [Agents documentation](https://developers.cloudflare.com/agents/) to learn more about the Agents SDK, the SDK APIs, as well as how to test and deploying agents to production.

Feb 25, 2025
1. ### [Workers AI now supports structured JSON outputs.](https://developers.cloudflare.com/changelog/post/2025-02-25-json-mode/)  
[ Workers AI ](https://developers.cloudflare.com/workers-ai/)  
Workers AI now supports structured JSON outputs with [JSON mode](https://developers.cloudflare.com/workers-ai/features/json-mode/), which allows you to request a structured output response when interacting with AI models.  
This makes it much easier to retrieve structured data from your AI models, and avoids the (error prone!) need to parse large unstructured text responses to extract your data.  
JSON mode in Workers AI is compatible with the OpenAI SDK's [structured outputs ↗](https://platform.openai.com/docs/guides/structured-outputs) `response_format` API, which can be used directly in a Worker:

  * [  JavaScript ](#tab-panel-3401)
  * [  TypeScript ](#tab-panel-3402)  
JavaScript  
```  
import { OpenAI } from "openai";  
// Define your JSON schema for a calendar eventconst CalendarEventSchema = {  type: "object",  properties: {    name: { type: "string" },    date: { type: "string" },    participants: { type: "array", items: { type: "string" } },  },  required: ["name", "date", "participants"],};  
export default {  async fetch(request, env) {    const client = new OpenAI({      apiKey: env.OPENAI_API_KEY,      // Optional: use AI Gateway to bring logs, evals & caching to your AI requests      // https://developers.cloudflare.com/ai-gateway/usage/providers/openai/      // baseUrl: "https://gateway.ai.cloudflare.com/v1/{account_id}/{gateway_id}/openai"    });  
    const response = await client.chat.completions.create({      model: "gpt-4o-2024-08-06",      messages: [        { role: "system", content: "Extract the event information." },        {          role: "user",          content: "Alice and Bob are going to a science fair on Friday.",        },      ],      // Use the `response_format` option to request a structured JSON output      response_format: {        // Set json_schema and provide ra schema, or json_object and parse it yourself        type: "json_schema",        schema: CalendarEventSchema, // provide a schema      },    });  
    // This will be of type CalendarEventSchema    const event = response.choices[0].message.parsed;  
    return Response.json({      calendar_event: event,    });  },};  
```  
TypeScript  
```  
import { OpenAI } from "openai";  
interface Env {  OPENAI_API_KEY: string;}  
// Define your JSON schema for a calendar eventconst CalendarEventSchema = {  type: "object",  properties: {    name: { type: "string" },    date: { type: "string" },    participants: { type: "array", items: { type: "string" } },  },  required: ["name", "date", "participants"],};  
export default {  async fetch(request: Request, env: Env) {    const client = new OpenAI({      apiKey: env.OPENAI_API_KEY,      // Optional: use AI Gateway to bring logs, evals & caching to your AI requests      // https://developers.cloudflare.com/ai-gateway/usage/providers/openai/      // baseUrl: "https://gateway.ai.cloudflare.com/v1/{account_id}/{gateway_id}/openai"    });  
    const response = await client.chat.completions.create({      model: "gpt-4o-2024-08-06",      messages: [        { role: "system", content: "Extract the event information." },        {          role: "user",          content: "Alice and Bob are going to a science fair on Friday.",        },      ],      // Use the `response_format` option to request a structured JSON output      response_format: {        // Set json_schema and provide ra schema, or json_object and parse it yourself        type: "json_schema",        schema: CalendarEventSchema, // provide a schema      },    });  
    // This will be of type CalendarEventSchema    const event = response.choices[0].message.parsed;  
    return Response.json({      calendar_event: event,    });  },};  
```  
To learn more about JSON mode and structured outputs, visit the [Workers AI documentation](https://developers.cloudflare.com/workers-ai/features/json-mode/).

Feb 25, 2025
1. ### [Concurrent Workflow instances limits increased.](https://developers.cloudflare.com/changelog/post/2025-02-25-workflows-concurrency-increased/)  
[ Workflows ](https://developers.cloudflare.com/workflows/)  
[Workflows](https://developers.cloudflare.com/workflows/) now supports up to 4,500 concurrent (running) instances, up from the previous limit of 100\. This limit will continue to increase during the Workflows open beta. This increase applies to all users on the Workers Paid plan, and takes effect immediately.  
Review the Workflows [limits documentation](https://developers.cloudflare.com/workflows/reference/limits) and/or dive into the [get started guide](https://developers.cloudflare.com/workflows/get-started/guide/) to start building on Workflows.

Feb 24, 2025
1. ### [Bind the Images API to your Worker](https://developers.cloudflare.com/changelog/post/2025-02-21-images-bindings-in-workers/)  
[ Cloudflare Images ](https://developers.cloudflare.com/images/)  
You can now [interact with the Images API](https://developers.cloudflare.com/images/optimization/binding/) directly in your Worker.  
This allows more fine-grained control over transformation request flows and cache behavior. For example, you can resize, manipulate, and overlay images without requiring them to be accessible through a URL.  
The Images binding can be configured in the Cloudflare dashboard for your Worker or in the Wrangler configuration file in your project's directory:

  * [  wrangler.jsonc ](#tab-panel-3399)
  * [  wrangler.toml ](#tab-panel-3400)  
JSONC  
```  
{  "images": {    "binding": "IMAGES", // i.e. available in your Worker on env.IMAGES  },}  
```  
TOML  
```  
[images]binding = "IMAGES"  
```  
Within your Worker code, you can interact with this binding by using `env.IMAGES`.  
Here's how you can rotate, resize, and blur an image, then output the image as AVIF:  
TypeScript  
```  
const info = await env.IMAGES.info(stream);// stream contains a valid image, and width/height is available on the info object  
const response = (  await env.IMAGES.input(stream)    .transform({ rotate: 90 })    .transform({ width: 128 })    .transform({ blur: 20 })    .output({ format: "image/avif" })).response();  
return response;  
```  
For more information, refer to [Images Bindings](https://developers.cloudflare.com/images/optimization/binding/).

Feb 24, 2025
1. ### [Super Slurper now supports migrations from all S3-compatible storage providers](https://developers.cloudflare.com/changelog/post/2025-02-24-r2-super-slurper-s3-compatible-support/)  
[ R2 ](https://developers.cloudflare.com/r2/)  
[Super Slurper](https://developers.cloudflare.com/r2/data-migration/super-slurper/) can now migrate data from any S3-compatible object storage provider to [Cloudflare R2](https://developers.cloudflare.com/r2/). This includes transfers from services like MinIO, Wasabi, Backblaze B2, and DigitalOcean Spaces.  
![Super Slurper S3-Compatible Source](https://developers.cloudflare.com/_astro/super-slurper-s3-compat-screenshot-border.D8Gd5eye_dt8CT.webp)  
For more information on Super Slurper and how to migrate data from your existing S3-compatible storage buckets to R2, refer to our [documentation](https://developers.cloudflare.com/r2/data-migration/super-slurper/).

Feb 24, 2025
1. ### [Workers AI larger context windows](https://developers.cloudflare.com/changelog/post/2025-02-24-context-windows/)  
[ Workers AI ](https://developers.cloudflare.com/workers-ai/)  
We've updated the Workers AI text generation models to include context windows and limits definitions and changed our APIs to estimate and validate the number of tokens in the input prompt, not the number of characters.  
This update allows developers to use larger context windows when interacting with Workers AI models, which can lead to better and more accurate results.  
Our [catalog page](https://developers.cloudflare.com/workers-ai/models/) provides more information about each model's supported context window.

Feb 24, 2025
1. ### [Zaraz moves to the “Tag Management” category in the Cloudflare dashboard](https://developers.cloudflare.com/changelog/post/2025-02-24-zaraz-dash-placement/)  
[ Zaraz ](https://developers.cloudflare.com/zaraz/)  
![Zaraz at zone level to Tag management at account level](https://developers.cloudflare.com/_astro/zaraz-account-level.L5Bz9oN0_151oOs.webp)  
Previously, you could only configure Zaraz by going to each individual zone under your Cloudflare account. Now, if you’d like to get started with Zaraz or manage your existing configuration, you can navigate to the [Tag Management ↗](https://dash.cloudflare.com/?to=/:account/tag-management/zaraz) section on the Cloudflare dashboard – this will make it easier to compare and configure the same settings across multiple zones.  
These changes will not alter any existing configuration or entitlements for zones you already have Zaraz enabled on. If you’d like to edit existing configurations, you can go to the [Tag Setup ↗](https://dash.cloudflare.com/?to=/:account/tag-management/zaraz) section of the dashboard, and select the zone you'd like to edit.

Feb 20, 2025
1. ### [Workers for Platforms - Instant dispatch for newly created User Workers](https://developers.cloudflare.com/changelog/post/2025-02-20-synchronous-uploads/)  
[ Workers for Platforms ](https://developers.cloudflare.com/cloudflare-for-platforms/workers-for-platforms/)  
[Workers for Platforms ↗](https://developers.cloudflare.com/cloudflare-for-platforms/) is an architecture wherein a centralized [dispatch Worker](https://developers.cloudflare.com/cloudflare-for-platforms/workers-for-platforms/how-workers-for-platforms-works/#dynamic-dispatch-worker) processes incoming requests and routes them to isolated sub-Workers, called [User Workers](https://developers.cloudflare.com/cloudflare-for-platforms/workers-for-platforms/how-workers-for-platforms-works/#user-workers).  
![Workers for Platforms Requests](https://developers.cloudflare.com/_astro/wfp-request.CZmZLaYf_Z2o8aKs.webp)  
Previously, when a new User Worker was uploaded, there was a short delay before it became available for dispatch. This meant that even though an API request could return a 200 OK response, the script might not yet be ready to handle requests, causing unexpected failures for platforms that immediately dispatch to new Workers.

**With this update, first-time uploads of User Workers are now deployed synchronously**. A 200 OK response guarantees the script is fully provisioned and ready to handle traffic immediately, ensuring more predictable deployments and reducing errors.

Feb 20, 2025
1. ### [Workers AI updated pricing](https://developers.cloudflare.com/changelog/post/2025-02-20-updated-pricing-docs/)  
[ Workers AI ](https://developers.cloudflare.com/workers-ai/)  
We've updated the Workers AI [pricing](https://developers.cloudflare.com/workers-ai/platform/pricing/) to include the latest models and how model usage maps to Neurons.

  * Each model's core input format(s) (tokens, audio seconds, images, etc) now include mappings to Neurons, making it easier to understand how your included Neuron volume is consumed and how you are charged at scale
  * Per-model pricing, instead of the previous bucket approach, allows us to be more flexible on how models are charged based on their size, performance and capabilities. As we optimize each model, we can then pass on savings for that model.
  * You will still only pay for what you consume: Workers AI inference is serverless, and not billed by the hour.  
Going forward, models will be launched with their associated Neuron costs, and we'll be updating the Workers AI dashboard and API to reflect consumption in both raw units and Neurons. Visit the [Workers AI pricing](https://developers.cloudflare.com/workers-ai/platform/pricing/) page to learn more about Workers AI pricing.

Feb 20, 2025
1. ### [Autofix Worker name configuration errors at build time](https://developers.cloudflare.com/changelog/post/2025-02-20-builds-name-conflict/)  
[ Workers ](https://developers.cloudflare.com/workers/)  
![Auto-fixing Workers Name in Git Repo](https://developers.cloudflare.com/_astro/gh-auto-pr-name.BHTtigEg_2smH.webp)  
Small misconfigurations shouldn’t break your deployments. Cloudflare is introducing automatic error detection and fixes in [Workers Builds](https://developers.cloudflare.com/workers/ci-cd/builds/), identifying common issues in your wrangler.toml or wrangler.jsonc and proactively offering fixes, so you spend less time debugging and more time shipping.  
Here's how it works:

  1. Before running your build, Cloudflare checks your Worker's Wrangler configuration file (wrangler.toml or wrangler.jsonc) for common errors.
  2. Once you submit a build, if Cloudflare finds an error it can fix, it will submit a pull request to your repository that fixes it.
  3. Once you merge this pull request, Cloudflare will run another build.  
We're starting with fixing name mismatches between your Wrangler file and the Cloudflare dashboard, a top cause of build failures.  
This is just the beginning, we want your feedback on what other errors we should catch and fix next. Let us know in the Cloudflare Developers Discord, [#workers-and-pages-feature-suggestions ↗](https://discord.com/channels/595317990191398933/1064502845061210152).

Feb 14, 2025
1. ### [Customize queue message retention periods](https://developers.cloudflare.com/changelog/post/2025-02-14-customize-queue-retention-period/)  
[ Queues ](https://developers.cloudflare.com/queues/)  
You can now customize a queue's message retention period, from a minimum of 60 seconds to a maximum of 14 days. Previously, it was fixed to the default of 4 days.  
![Customize a queue's message retention period](https://developers.cloudflare.com/_astro/customize-retention-period.CpK7s10q_19dmJh.webp)  
You can customize the retention period on the settings page for your queue, or using Wrangler:  
Update message retention period  
```  
$ wrangler queues update my-queue --message-retention-period-secs 600  
```  
This feature is available on all new and existing queues. If you haven't used Cloudflare Queues before, [get started with the Cloudflare Queues guide](https://developers.cloudflare.com/queues/get-started).

Feb 14, 2025
1. ### [Build AI Agents with Example Prompts](https://developers.cloudflare.com/changelog/post/2025-02-14-example-ai-prompts/)  
[ Agents ](https://developers.cloudflare.com/agents/)[ Workers ](https://developers.cloudflare.com/workers/)[ Workflows ](https://developers.cloudflare.com/workflows/)  
We've added an [example prompt](https://developers.cloudflare.com/workers/get-started/prompting/) to help you get started with building AI agents and applications on Cloudflare [Workers](https://developers.cloudflare.com/workers/), including [Workflows](https://developers.cloudflare.com/workflows/), [Durable Objects](https://developers.cloudflare.com/durable-objects/), and [Workers KV](https://developers.cloudflare.com/kv/).  
You can use this prompt with your favorite AI model, including Claude 3.5 Sonnet, OpenAI's o3-mini, Gemini 2.0 Flash, or Llama 3.3 on Workers AI. Models with large context windows will allow you to paste the prompt directly: provide your own prompt within the `<user_prompt></user_prompt>` tags.  
Terminal window  
```  
{paste_prompt_here}<user_prompt>user: Build an AI agent using Cloudflare Workflows. The Workflow should run when a new GitHub issue is opened on a specific project with the label 'help' or 'bug', and attempt to help the user troubleshoot the issue by calling the OpenAI API with the issue title and description, and a clear, structured prompt that asks the model to suggest 1-3 possible solutions to the issue. Any code snippets should be formatted in Markdown code blocks. Documentation and sources should be referenced at the bottom of the response. The agent should then post the response to the GitHub issue. The agent should run as the provided GitHub bot account.</user_prompt>  
```  
This prompt is still experimental, but we encourage you to try it out and [provide feedback ↗](https://github.com/cloudflare/cloudflare-docs/issues/new?template=content.edit.yml).

Feb 14, 2025
1. ### [Super Slurper now transfers data to R2 up to 5x faster](https://developers.cloudflare.com/changelog/post/2025-02-14-r2-super-slurper-faster-migrations/)  
[ R2 ](https://developers.cloudflare.com/r2/)  
[Super Slurper](https://developers.cloudflare.com/r2/data-migration/super-slurper/) now transfers data from cloud object storage providers like AWS S3 and Google Cloud Storage to [Cloudflare R2](https://developers.cloudflare.com/r2/) up to 5x faster than it did before.  
We moved from a centralized service to a distributed system built on the Cloudflare Developer Platform — using [Cloudflare Workers](https://developers.cloudflare.com/workers/), [Durable Objects](https://developers.cloudflare.com/durable-objects/), and [Queues](https://developers.cloudflare.com/queues/) — to both improve performance and increase system concurrency capabilities (and we'll share more details about how we did it soon!)  
![Super Slurper Objects Migrated](https://developers.cloudflare.com/_astro/slurper-objects-over-time-border.BFDkMQUw_KFpzV.webp)  
_Time to copy 75,000 objects from AWS S3 to R2 decreased from 15 minutes 30 seconds (old) to 3 minutes 25 seconds (after performance improvements)_  
For more information on Super Slurper and how to migrate data from existing object storage to R2, refer to our [documentation](https://developers.cloudflare.com/r2/data-migration/super-slurper/).

Feb 14, 2025
1. ### [Rewind, Replay, Resume: Introducing DVR for Stream Live](https://developers.cloudflare.com/changelog/post/2025-02-14-introducing-dvr-for-stream-live/)  
[ Stream ](https://developers.cloudflare.com/stream/)  
Previously, all viewers watched "the live edge," or the latest content of the broadcast, synchronously. If a viewer paused for more than a few seconds, the player would automatically "catch up" when playback started again. Seeking through the broadcast was only available once the recording was available after it concluded.  
Starting today, customers can make a small adjustment to the player embed or manifest URL to enable the DVR experience for their viewers. By offering this feature as an opt-in adjustment, our customers are empowered to pick the best experiences for their applications.  
When building a player embed code or manifest URL, just add `dvrEnabled=true` as a query parameter. There are some things to be aware of when using this option. For more information, refer to [DVR for Live](https://developers.cloudflare.com/stream/stream-live/dvr-for-live/).

Feb 07, 2025
1. ### [Create and deploy Workers from Git repositories](https://developers.cloudflare.com/changelog/post/2025-02-07-new-ways-to-get-started-on-workers/)  
[ Workers ](https://developers.cloudflare.com/workers/)  
![Import repo or choose template](https://developers.cloudflare.com/_astro/choose-template-import-repo.Ci4KQPnT_17oN4z.webp)  
You can now create a Worker by:

  * **Importing a Git repository**: Choose an existing Git repo on your GitHub/GitLab account and set up [Workers Builds](https://developers.cloudflare.com/workers/ci-cd/builds/configuration/) to deploy your Worker.
  * **Deploying a template with Git**: Choose from a brand new selection of production ready [examples ↗](https://github.com/cloudflare/templates) to help you get started with popular frameworks like [Astro ↗](https://astro.build/), [Remix ↗](https://remix.run/) and [Next ↗](https://nextjs.org/) or build stateful applications with Cloudflare resources like [D1 databases](https://developers.cloudflare.com/d1/), [Workers AI](https://developers.cloudflare.com/workers-ai/) or [Durable Objects](https://developers.cloudflare.com/durable-objects/)! When you're ready to deploy, Cloudflare will set up your project by cloning the template to your GitHub/GitLab account, provisioning any required [resources](https://developers.cloudflare.com/workers/runtime-apis/bindings/) and deploying your Worker.  
With every push to your chosen branch, Cloudflare will automatically build and deploy your Worker.  
To get started, go to the [Workers dashboard ↗](https://dash.cloudflare.com/?to=/:account/workers-and-pages/create).  
These new features are available today in the Cloudflare dashboard to a subset of Cloudflare customers, and will be coming to all customers in the next few weeks. Don't see it in your dashboard, but want early access? Add your Cloudflare Account ID to [this form ↗](https://forms.gle/U1qhkF2snNJDGJJa9).

Feb 06, 2025
1. ### [Request timeouts and retries with AI Gateway](https://developers.cloudflare.com/changelog/post/2025-02-05-aig-request-handling/)  
[ AI Gateway ](https://developers.cloudflare.com/ai-gateway/)  
AI Gateway adds additional ways to handle requests - [Request Timeouts](https://developers.cloudflare.com/ai-gateway/configuration/request-handling/#request-timeouts) and [Request Retries](https://developers.cloudflare.com/ai-gateway/configuration/request-handling/#request-retries), making it easier to keep your applications responsive and reliable.  
Timeouts and retries can be used on both the [Universal Endpoint](https://developers.cloudflare.com/ai-gateway/usage/universal/) or directly to a [supported provider](https://developers.cloudflare.com/ai-gateway/usage/providers/).

**Request timeouts**A [request timeout](https://developers.cloudflare.com/ai-gateway/configuration/request-handling/#request-timeouts) allows you to trigger [fallbacks](https://developers.cloudflare.com/ai-gateway/configuration/fallbacks/) or a retry if a provider takes too long to respond.  
To set a request timeout directly to a provider, add a `cf-aig-request-timeout` header.  
Provider-specific endpoint example  
```  
curl https://gateway.ai.cloudflare.com/v1/{account_id}/{gateway_id}/workers-ai/@cf/meta/llama-3.1-8b-instruct \ --header 'Authorization: Bearer {cf_api_token}' \ --header 'Content-Type: application/json' \ --header 'cf-aig-request-timeout: 5000' --data '{"prompt": "What is Cloudflare?"}'  
```

**Request retries**A [request retry](https://developers.cloudflare.com/ai-gateway/configuration/request-handling/#request-retries) automatically retries failed requests, so you can recover from temporary issues without intervening.  
To set up request retries directly to a provider, add the following headers:

  * cf-aig-max-attempts (number)
  * cf-aig-retry-delay (number)
  * cf-aig-backoff ("constant" | "linear" | "exponential)

Feb 05, 2025
1. ### [AI Gateway adds Cerebras, ElevenLabs, and Cartesia as new providers](https://developers.cloudflare.com/changelog/post/2025-02-04-aig-provider-cartesia-eleven-cerebras/)  
[ AI Gateway ](https://developers.cloudflare.com/ai-gateway/)  
[AI Gateway](https://developers.cloudflare.com/ai-gateway/) has added three new providers: [Cartesia](https://developers.cloudflare.com/ai-gateway/usage/providers/cartesia/), [Cerebras](https://developers.cloudflare.com/ai-gateway/usage/providers/cerebras/), and [ElevenLabs](https://developers.cloudflare.com/ai-gateway/usage/providers/elevenlabs/), giving you more even more options for providers you can use through AI Gateway. Here's a brief overview of each:

  * [Cartesia](https://developers.cloudflare.com/ai-gateway/usage/providers/cartesia/) provides text-to-speech models that produce natural-sounding speech with low latency.
  * [Cerebras](https://developers.cloudflare.com/ai-gateway/usage/providers/cerebras/) delivers low-latency AI inference to Meta's Llama 3.1 8B and Llama 3.3 70B models.
  * [ElevenLabs](https://developers.cloudflare.com/ai-gateway/usage/providers/elevenlabs/) offers text-to-speech models with human-like voices in 32 languages.  
![Example of Cerebras log in AI Gateway](https://developers.cloudflare.com/_astro/cerebras2.qHYP0ZnF_XMtnx.webp)  
To get started with AI Gateway, just update the base URL. Here's how you can send a request to [Cerebras](https://developers.cloudflare.com/ai-gateway/usage/providers/cerebras/) using cURL:  
Example fetch request  
```  
curl -X POST https://gateway.ai.cloudflare.com/v1/ACCOUNT_TAG/GATEWAY/cerebras/chat/completions \ --header 'content-type: application/json' \ --header 'Authorization: Bearer CEREBRAS_TOKEN' \ --data '{    "model": "llama-3.3-70b",    "messages": [        {            "role": "user",            "content": "What is Cloudflare?"        }    ]}'  
```

Feb 03, 2025
1. ### [Terraform v5 Provider is now generally available](https://developers.cloudflare.com/changelog/post/2025-02-03-terraform-v5-provider/)  
[ Cloudflare Fundamentals ](https://developers.cloudflare.com/fundamentals/)[ Terraform ](https://developers.cloudflare.com/terraform/)  
![Screenshot of Terraform defining a Zone](https://developers.cloudflare.com/_astro/2024-02-03-terraform-v5-screenshot.mW8OaFoS_Z2pw8Bq.webp)  
Cloudflare's v5 Terraform Provider is now generally available. With this release, Terraform resources are now automatically generated based on OpenAPI Schemas. This change brings alignment across our SDKs, API documentation, and now Terraform Provider. The new provider boosts coverage by increasing support for API properties to 100%, adding 25% more resources, and more than 200 additional data sources. Going forward, this will also reduce the barriers to bringing more resources into Terraform across the broader Cloudflare API. This is a small, but important step to making more of our platform manageable through GitOps, making it easier for you to manage Cloudflare just like you do your other infrastructure.  
The Cloudflare Terraform Provider v5 is a ground-up rewrite of the provider and introduces breaking changes for some resource types. Please refer to the [upgrade guide ↗](https://registry.terraform.io/providers/cloudflare/cloudflare/latest/docs/guides/version-5-upgrade) for best practices, or the [blog post on automatically generating Cloudflare's Terraform Provider ↗](https://blog.cloudflare.com/automatically-generating-cloudflares-terraform-provider/) for more information about the approach.  
For more info

  * [Terraform provider ↗](https://registry.terraform.io/providers/cloudflare/cloudflare/latest/docs)
  * [Documentation on using Terraform with Cloudflare ↗](https://developers.cloudflare.com/terraform/)

Feb 03, 2025
1. ### [Revamped Workers Metrics](https://developers.cloudflare.com/changelog/post/2025-02-03-workers-metrics-revamp/)  
[ Workers ](https://developers.cloudflare.com/workers/)  
We've revamped the [Workers Metrics dashboard ↗](https://dash.cloudflare.com/?to=/:account/workers/services/view/:worker/production/metrics/).  
![Workers Metrics dashboard](https://developers.cloudflare.com/_astro/workers-metrics.IxYk9yF0_Z1h2eg9.webp)  
Now you can easily compare metrics across Worker versions, understand the current state of a [gradual deployment](https://developers.cloudflare.com/workers/configuration/versions-and-deployments/gradual-deployments/), and review key Workers metrics in a single view. This new interface enables you to:

  * Drag-and-select using a graphical timepicker for precise metric selection.  
![Workers Metrics graphical timepicker](https://developers.cloudflare.com/_astro/metrics-graphical-timepicker.tzLlEF5U_Z102O4.webp)  
  * Use histograms to visualize cumulative metrics, allowing you to bucket and compare rates over time.
  * Focus on Worker versions by directly interacting with the version numbers in the legend.  
![Workers Metrics legend selector](https://developers.cloudflare.com/_astro/metrics-legend-selector.B2GY90Hn_27rpVV.webp)  
  * Monitor and compare active gradual deployments.
  * Track error rates across versions with grouping both by version and by invocation status.
  * Measure how [Smart Placement](https://developers.cloudflare.com/workers/configuration/placement/) improves request duration.  
Learn more about [metrics](https://developers.cloudflare.com/workers/observability/metrics-and-analytics).

```json
{"@context":"https://schema.org","@type":"BlogPosting","@id":"https://developers.cloudflare.com/changelog/product-group/developer-platform/17/#page","headline":"Developer platform Changelog | Cloudflare Docs","url":"https://developers.cloudflare.com/changelog/product-group/developer-platform/17/","inLanguage":"en","image":"https://developers.cloudflare.com/cf-twitter-card.png","publisher":{"@type":"Organization","name":"Cloudflare","url":"https://www.cloudflare.com/"},"isPartOf":{"@type":"WebSite","@id":"https://developers.cloudflare.com/#website","name":"Cloudflare Docs","url":"https://developers.cloudflare.com/"}}
```
